<?php

if (!defined('FORUM')) die();

if ($action == 'quick_search_find_topics') 
{
	if (!isset($value['item_id']) || !isset($value['keywords']) || !isset($value['back_url']))
		message($lang_common['Bad request']);
	
	$like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';
				
	$query = array(
		'SELECT'	=> 't.id AS tid, t.poster, t.subject, t.first_post_id, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_replies, t.closed, t.sticky, t.forum_id, f.forum_name',
		'FROM'		=> 'topics AS t',
		'JOINS'		=> array(
		    array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
		    ),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			)
		),
		'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND t.forum_id='.$value['item_id'].' AND t.subject '.$like_command.' \'%'.$forum_db->escape($value['keywords']).'%\'',
		'ORDER BY'	=> 't.last_post DESC'
	);

	if (!$forum_user['is_guest'] && $forum_config['o_show_dot'] == '1')
	{
		$query['SELECT'] .= ', p.poster_id AS has_posted';
		$query['JOINS'][]	= array(
			'LEFT JOIN'		=> 'posts AS p',
			'ON'			=> '(p.poster_id='.$forum_user['id'].' AND p.topic_id=t.id)'
		);

		$query['GROUP BY'] = 't.id, t.poster, t.subject, t.first_post_id, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_replies, t.closed, t.sticky, t.forum_id, f.forum_name, p.poster_id';
	}

	$url_type = $forum_url['quick_search_find_topics'];
	$sf_args = [urlencode($value['back_url']), $value['item_id'], $value['keywords'],];
	
	for ($i = 0; isset($sf_args[$i]); ++$i)
		$url_type = str_replace('$'.($i + 1), $sf_args[$i], $url_type);

	$search_id = ['item_id' => $value['item_id'], 'keywords' => $value['keywords'], 'back_url' => $value['back_url'],];

    ($hook = get_hook('quick_search_generate_action_search_query_qr_get_topics')) ? eval($hook) : null;
}
else if ($action == 'quick_search_find_posts') 
{
	if (!isset($value['item_id']) || !isset($value['keywords']) || !isset($value['back_url']))
		message($lang_common['Bad request']);
	
	$like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';

	$query = array(
		'SELECT'	=> 'p.id AS pid, p.poster AS pposter, p.posted AS pposted, p.poster_id, p.message, p.hide_smilies, t.id AS tid, t.poster, t.subject, t.first_post_id, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_replies, t.forum_id, f.forum_name',
		'FROM'		=> 'posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'topics AS t',
				'ON'			=> 't.id=p.topic_id'
			),
			array(
				'INNER JOIN'	=> 'forums AS f',
				'ON'			=> 'f.id=t.forum_id'
			),
			array(
				'LEFT JOIN'		=> 'forum_perms AS fp',
				'ON'			=> '(fp.forum_id=f.id AND fp.group_id='.$forum_user['g_id'].')'
			)
		),
		'WHERE'		=> '(fp.read_forum IS NULL OR fp.read_forum=1) AND p.topic_id='.$value['item_id'].' AND p.message '.$like_command.' \'%'.$forum_db->escape($value['keywords']).'%\'',
		'ORDER BY'	=> 'p.posted DESC'
	);

	$url_type = $forum_url['quick_search_find_posts'];
	$sf_args = [urlencode($value['back_url']), $value['item_id'], $value['keywords'],];
	
	for ($i = 0; isset($sf_args[$i]); ++$i)
		$url_type = str_replace('$'.($i + 1), $sf_args[$i], $url_type);

	$search_id = ['item_id' => $value['item_id'], 'keywords' => $value['keywords'], 'back_url' => $value['back_url'],];
	$show_as = 'posts';
	
	($hook = get_hook('quick_search_generate_action_search_query_qr_get_posts')) ? eval($hook) : null;
}
